public class Frame
{
    private int    ball1;
    private int    ball2;
    private Frame nextFrame;

    public Frame()
    {
        ball1 = -1;
        ball2 = -1;
        nextFrame = null;
    }

    public void roll( int ball )
    {
        if ( ball1 == -1 )
            ball1 = ball;
        else if ( ball2 == -1 )
            ball2 = ball;
        else
        {
            if ( nextFrame == null )
                nextFrame = new Frame();
            nextFrame.roll( ball );
        }
    }

    public int score()
    {
        int total = ball1 + ball2;
        if ( total < 10 )
            return ball1 + ball2;
        return 10 + nextFrame.firstBall();
    }

    public int gameScore()
    {
        if ( nextFrame == null )
            return score();
        return score() + nextFrame.gameScore();
    }

    private int firstBall()
    {
        return ball1;
    }
}
