import junit.framework.*;

public class FrameTest extends TestCase
{
    protected void setUp()
    {
    }

    public void testSingleOpenFrame()
    {
        Frame open = new Frame();
        open.roll( 4 );
        open.roll( 2 );
        assertEquals( 6, open.score() );
    }

    public void testTwoOpenFrames()
    {
        Frame open = new Frame();
        open.roll( 4 );
        open.roll( 2 );
        open.roll( 3 );
        open.roll( 5 );
        assertEquals( 6, open.score() );
    }

    public static Test suite()
    {
        return new TestSuite( FrameTest.class );
    }

    public static void main( String[] args )
    {
        junit.textui.TestRunner.run( suite() );
    }
}
